/***************************************************************************
                          main.c  -  description
                             -------------------
    begin                : Fre Nov 10 16:22:38 CET 2000
    copyright            : (C) 2000 by Markus Fruehwirth
    email                : 7ox@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "SJBMatrix.h"


/* name: matrix
 * var: none
 * exitcode:0 (for normal termination - returncode)
 * explanation: generates from mappingfile a vector
*/
int
doit (char *filename)
{
  int back;
  FILE *read, *write;		//filename
  char *line, *saveline;	//line
  int value, *valuep;		//values
  char *wordp;			//input words
  int mapxdim, mapydim;		//Dimensions of input map
  double **minima;
  double **am;
  linklist *start_pointer;	/* Define pointers to the structure     */
  linklist *next_pointer, *runner;
  int ende, stop, insert;	//break
  int x, y, *xp, *yp;		//matrix
  double error, *errorp;	//calculations
  char current;			//current input
  char *songtitle;		//songname
  int i, u, v;			//counter

  insert = 0;
  i = 0;
  current = 0;
  error = 0;
  ende = 0;
  stop = 0;
  x = 0;
  y = 0;
  back = 0;
  value = 0;
  mapxdim = 0;
  mapydim = 0;
  start_pointer = NULL;
  runner = NULL;
  next_pointer = NULL;
  start_pointer = (linklist *) malloc (sizeof (linklist));
  start_pointer->name[0] = '\0';
  start_pointer->next = NULL;
  next_pointer = start_pointer;


  errorp = &error;
  xp = &x;
  yp = &y;
  valuep = &value;

  wordp = malloc (MAXLENLINE * sizeof (char));
  songtitle = malloc (MAXSONG * sizeof (char));
  line = malloc (MAXLENLINE * sizeof (char));
  saveline = malloc (MAXLENLINE * sizeof (char));

  read = fopen (filename, "r");

  if (read == NULL)		//no file opened
    exit (-1);

  saveline = fgets (line, MAXLENLINE, read);
  saveline = fgets (line, MAXLENLINE, read);
  saveline = fgets (line, MAXLENLINE, read);
//read now XDIM

  back = sscanf (line, "%s %d", wordp, valuep);
  mapxdim = value;

  saveline = fgets (line, MAXLENLINE, read);

  back = sscanf (line, "%s %d", wordp, valuep);
  mapydim = value;

//Dimensions of map now clear

  minima = dmatrix (0, mapxdim, 0, mapydim);

//filling arrays

  ende = FALSE;
  while (ende == FALSE)
    {
      saveline = fgets (line, MAXLENLINE, read);
      if (saveline == NULL)
	ende = TRUE;
      if (ende == FALSE)
	{
	  back = sscanf (line, "%d %d %s %lf", xp, yp, wordp, errorp);

//write minimum to minimamatrix
	  if ((minima[x][y] == 0) || (minima[x][y] > error))
	    minima[x][y] = error;

//insert name
	  stop = FALSE;
	  i = 0;
	  while (stop != TRUE)	//convert name
	    {
	      current = wordp[i];
	      i++;

	      if (current == '\0')
		stop = TRUE;

	      if ((current == ASCIIDOT) && (stop == 3))
		stop = TRUE;

	      if ((current == ASCIIDOT) && (stop == FALSE))
		stop = 3;

	    }			//stop
// in i steht jetzt die Position des zweiten Punktes
	  strncpy (songtitle, wordp, i - 1);
	  songtitle[i - 1] = '\0';
//Songname now in songtitle

//search if already in list, if not insert the name
	  insert = TRUE;
	  runner = start_pointer;
	  while (runner != NULL)
	    {
	      if (strcmp (runner->name, songtitle) == 0)
		insert = FALSE;
	      runner = runner->next;
	    }
	  if (insert == TRUE)
	    {
	      next_pointer->next = (linklist *) malloc (sizeof (linklist));
	      next_pointer = next_pointer->next;
	      strcpy (next_pointer->name, songtitle);
	      next_pointer->next = NULL;
	    }
//now inserted!
	}			//if ende
    }				//ende
//file ready
//all filenames in list
//minima-Matrix is filled

  (void) fclose (read);
  read = NULL;

//now the dirty part starts
  write = stdout;

  i = 0;
  runner = start_pointer;
  while (runner != NULL)
    {
      runner = runner->next;
      i++;
    }
  i--;
  fprintf (write, "$TYPE %s\n$XDIM %d\n$YDIM %d\n$VEC_DIM %d\n", filename, i,
	   YDIM, (mapxdim * mapydim));
  am = dmatrix (0, mapxdim, 0, mapydim);
//Header written
//do for every word in the list
  runner = start_pointer;
  runner = runner->next;
  while (runner != NULL)
    {
      read = fopen (filename, "r");
      if (read == NULL)
	exit (-1);
//cut intro
      saveline = fgets (line, MAXLENLINE, read);
      saveline = fgets (line, MAXLENLINE, read);
      saveline = fgets (line, MAXLENLINE, read);
      saveline = fgets (line, MAXLENLINE, read);
//now read lines

      ende = FALSE;
      while (ende != TRUE)
	{
	  saveline = fgets (line, MAXLENLINE, read);

	  if (saveline == NULL)
	    ende = TRUE;
	  if (ende == FALSE)
	    {
	      back = sscanf (line, "%d %d %s %lf", xp, yp, wordp, errorp);

	      stop = FALSE;
	      i = 0;
	      while (stop != TRUE)	//covert names
		{
		  current = wordp[i];
		  i++;

		  if (current == '\0')
		    stop = TRUE;

		  if ((current == ASCIIDOT) && (stop == 3))
		    stop = TRUE;

		  if ((current == ASCIIDOT) && (stop == FALSE))
		    stop = 3;

		}		//stop
//in i is now the position of second dot
	      strncpy (songtitle, wordp, i - 1);
	      songtitle[i - 1] = '\0';
//name of song now in songtitle

//is this the serched song
	      insert = FALSE;
	      if (strcmp (runner->name, songtitle) == 0)
		insert = TRUE;

	      if (insert == TRUE)
		{
//insert song

//calculating distance
		  error = error / minima[x][y];

		  error = 1 - (error / 10);

		  if (error < (WEIGHT / 9))
		    {
//equaly weighted
		      error = (WEIGHT / 9);
		      am[x][y] = am[x][y] + error;	//middle
		    }
		  else
		    {
//other weight
		      am[x][y] = am[x][y] + error;	//middle
//add faktor
		      error = (WEIGHT - error) / 8;
		    }

//do the other 8 fields (neighbours)
// don't need to control upper fields, array is large enough
		  if (x > 0)
		    {
		      if (y > 0)
			am[x - 1][y - 1] = am[x - 1][y - 1] + error;
		      am[x - 1][y] = am[x - 1][y] + error;
		      am[x - 1][y + 1] = am[x - 1][y + 1] + error;
		    }
		  if (y > 0)
		    am[x][y - 1] = am[x][y - 1] + error;
		  am[x][y + 1] = am[x][y + 1] + error;
		  if (y > 0)
		    am[x + 1][y - 1] = am[x + 1][y - 1] + error;
		  am[x + 1][y] = am[x + 1][y] + error;
		  am[x + 1][y + 1] = am[x + 1][y + 1] + error;

//weighted done
//read next line
		}		//if insert
	    }			//if ende
	}			// while ende - EOF

// one song done, now print results
      for (u = 0; u < mapxdim; u++)
	for (v = 0; v < mapydim; v++)
	  {
	    fprintf (write, "%f ", (double) am[u][v]);
	    am[u][v] = 0;
	  }

      fprintf (write, "%s\n", runner->name);

      (void) fclose (read);
      (void) fflush (write);
      runner = runner->next;

    }				//while runner

  (void) free_dmatrix (am, 0, mapxdim, 0, mapydim);
  (void) free_dmatrix (minima, 0, mapxdim, 0, mapydim);

  if (back > 0)
    back = 0;

  return back;
}


/* name: main
 * var: none
 * exitcode:0 (for normal termination - returncode)
 * explanation: calls doit
*/
int
main (int argc, char *argv[])
{
  int back = -1;

  if (argc == 2)
    back = doit (argv[1]);
  else
    {
      (void) fprintf (stderr, "%s: wrong Usage: %s filename\n", argv[0], argv[0]);
      exit (EXIT_FAILURE);
    }
  return back;
}
